// OptionSheet.cpp :  Դϴ.
//

#include "stdafx.h"
#include "Resource.h"
#include "OptionSheet.h"
#include "Migration.h"


// COptionSheet

IMPLEMENT_DYNAMIC(COptionSheet, CPropertySheet)

COptionSheet::COptionSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_cPage1);
	AddPage(&m_cPage2);
	AddPage(&m_cPage3);

	m_psh.dwFlags |= PSH_NOAPPLYNOW;
	m_psh.dwFlags &= ~PSH_HASHELP;
}

COptionSheet::COptionSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_cPage1);
	AddPage(&m_cPage2);
	AddPage(&m_cPage3);

	m_psh.dwFlags |= PSH_NOAPPLYNOW;
	m_psh.dwFlags &= ~PSH_HASHELP;
}

COptionSheet::~COptionSheet()
{
	if(m_cPage1.m_bOK || m_cPage2.m_bOK || m_cPage3.m_bOK)
	{
		//ɼ !
		//Page1
		m_cFileOption.Clear();

		m_cFileOption.SetOptionString(L"_Format",L"V2"); //Ź 

		m_cFileOption.SetOptionString(L"strRetChar",m_cPage1.m_strRetChar.GetString());
		m_cFileOption.SetOptionInt(L"MaxChar",m_cPage1.m_nMaxChar);
		m_cFileOption.SetOptionInt(L"MaxLine",m_cPage1.m_nMaxLine);
		m_cFileOption.SetOptionInt(L"IgnoreLine",m_cPage1.m_nIgnoreLine);
		m_cFileOption.SetOptionInt(L"UseLimitLine",m_cPage1.m_bLimitLine);
		m_cFileOption.SetOptionInt(L"IgnoreNonTrans",m_cPage1.m_bNonTrans);
		m_cFileOption.SetOptionInt(L"UseRetChar",m_cPage1.m_bUseRetChar);
		m_cFileOption.SetOptionInt(L"UseRet",m_cPage1.m_bUseRet);
		
		if(m_cPage1.m_nMaxLen>=0)	m_cFileOption.SetOptionInt(L"ForceLen",m_cPage1.m_bForceLen);
		else						m_cFileOption.SetOptionInt(L"ForceLen",0);

		m_cFileOption.SetOptionInt(L"MaxLen",m_cPage1.m_nMaxLen);

		//Page2
		for(int i=0;i<m_cPage2.m_FuncPool.size();i++)
		{
			m_cFileOption.SetOptionInt(L"ElemType",i,m_cPage2.m_FuncPool3[i]);
			for(int j=0;j<m_cPage2.m_FuncPool[i].size();j++)
			{
				m_cFileOption.SetOptionInt(L"ElemSubSize",i,j,m_cPage2.m_FuncPool[i][j].nSize);
				m_cFileOption.SetOptionInt(L"ElemSubTrans",i,j,m_cPage2.m_FuncPool[i][j].bTrans);
				m_cFileOption.SetOptionInt(L"ElemSubDel",i,j,m_cPage2.m_FuncPool[i][j].bDel);
				m_cFileOption.SetOptionInt(L"ElemSubPass",i,j,m_cPage2.m_FuncPool[i][j].bPass);
				m_cFileOption.SetOptionString(L"ElemSubString",i,j,m_cPage2.m_FuncPool[i][j].strText.GetString());
				m_cFileOption.SetOptionInt(L"ElemSubMin",i,j,m_cPage2.m_FuncPool[i][j].nMin);
				m_cFileOption.SetOptionInt(L"ElemSubMax",i,j,m_cPage2.m_FuncPool[i][j].nMax);
				m_cFileOption.SetOptionInt(L"ElemSubFunc",i,j,m_cPage2.m_FuncPool[i][j].bFunc);
			}
		}

		//Page3
		set<CString>::iterator iterTemp=m_cPage3.m_NameSet.begin();
		int k=0;
		while(iterTemp!=m_cPage3.m_NameSet.end())
		{
			m_cFileOption.SetOptionString(L"Name",k,iterTemp->GetString());
			k++;
			iterTemp++;
		}

		//
		m_cFileOption.SaveOptionFile();
	}
}

BOOL COptionSheet::OnInitDialog()
{
	m_cFileOption.SetOptionFile(L"ATData\\FixLine.dat");
	m_cFileOption.Clear();
	m_cFileOption.OpenOptionFile();
	
	if(m_cFileOption.GetOptionString(L"_Format").compare(L"V2")!=0)
	{
		//̱׷̼
		CMigration::Migration(L"ATData\\FixLine.dat");
		m_cFileOption.Clear();
		m_cFileOption.OpenOptionFile();
	}

	if(m_cFileOption.IsInData(L"strRetChar"))
	{
		m_cPage1.m_strRetChar = m_cFileOption.GetOptionString(L"strRetChar").c_str();
	}
	else
	{
		m_cPage1.m_strRetChar = "\\n";
	}
	m_cPage1.m_nIgnoreLine = m_cFileOption.GetOptionInt(L"IgnoreLine");
	if(m_cFileOption.IsInData(L"MaxChar"))
	{
		m_cPage1.m_nMaxChar = m_cFileOption.GetOptionInt(L"MaxChar");
	}
	else
	{
		m_cPage1.m_nMaxChar = 40;
	}
	if(m_cFileOption.IsInData(L"MaxLine"))
	{
		m_cPage1.m_nMaxLine = m_cFileOption.GetOptionInt(L"MaxLine");
	}
	else
	{
		m_cPage1.m_nMaxLine = 3;
	}
	m_cPage1.m_bLimitLine = m_cFileOption.GetOptionBool(L"UseLimitLine");
	m_cPage1.m_bNonTrans = m_cFileOption.GetOptionBool(L"IgnoreNonTrans");
	m_cPage1.m_bUseRetChar = m_cFileOption.GetOptionBool(L"UseRetChar");
	m_cPage1.m_bUseRet = m_cFileOption.GetOptionBool(L"UseRet");

	m_cPage1.m_nMaxLen = m_cFileOption.GetOptionInt(L"MaxLen");
	m_cPage1.m_bForceLen = m_cFileOption.GetOptionBool(L"ForceLen");


	int nFuncN=0;
	m_cPage2.m_FuncPool.clear();
	while(m_cFileOption.IsInData(L"ElemType",nFuncN))
	{
		m_cPage2.m_FuncPool3.push_back(m_cFileOption.GetOptionInt(L"ElemType",nFuncN));
		vector <FLStringElement2> Temp;

		int nSubN=0;
		while(m_cFileOption.IsInData(L"ElemSubType",nFuncN,nSubN))
		{
			FLStringElement2 FLStringTemp;
			FLStringTemp.nSize = m_cFileOption.GetOptionInt(L"ElemSubSize",nFuncN,nSubN);
			FLStringTemp.bTrans = m_cFileOption.GetOptionBool(L"ElemSubTrans",nFuncN,nSubN);
			FLStringTemp.bDel = m_cFileOption.GetOptionBool(L"ElemSubDel",nFuncN,nSubN);
			FLStringTemp.bPass = m_cFileOption.GetOptionBool(L"ElemSubPass",nFuncN,nSubN);
			FLStringTemp.strText = m_cFileOption.GetOptionString(L"ElemSubString",nFuncN,nSubN).c_str();
			FLStringTemp.nMin = m_cFileOption.GetOptionInt(L"ElemSubMin",nFuncN,nSubN);
			FLStringTemp.nMax = m_cFileOption.GetOptionInt(L"ElemSubMax",nFuncN,nSubN);
			FLStringTemp.bFunc = m_cFileOption.GetOptionBool(L"ElemSubFunc",nFuncN,nSubN);
			Temp.push_back(FLStringTemp);

			nSubN++;
		}

		m_cPage2.m_FuncPool.push_back(Temp);

		CString strTemp;
		for(int i=0;i<Temp.size();i++)
		{
			strTemp += Temp[i].strText;
		}

		m_cPage2.m_FuncPool2.push_back(strTemp);

		nFuncN++;
	}

	int nNameN=0;
	m_cPage3.m_NameSet.clear();
	while(m_cFileOption.IsInData(L"Name",nNameN))
	{
		m_cPage3.m_NameSet.insert(m_cFileOption.GetOptionString(L"Name",nNameN).c_str());
		nNameN++;
	}

	CRect tmpRect;
	GetWindowRect(tmpRect);

	CStatic*	ctrStatic = new CStatic;
	CFont *tFont = this->GetFont();
	
	ctrStatic->Create(L"Hide_D,\r\nA",WS_CHILD|WS_VISIBLE|WS_DISABLED|SS_LEFT,CRect(10,tmpRect.Height()+36,120,tmpRect.Height()+66),this);

	CPropertySheet::OnInitDialog();

	
	ctrStatic->SetFont(tFont);

	return FALSE;
}


BEGIN_MESSAGE_MAP(COptionSheet, CPropertySheet)
END_MESSAGE_MAP()